monads-tf-0.3.0.1: Monad classes, using type families

Copyright | (c) Michael Weber <michael.weber@post.rwth-aachen.de> 2001 (c) Jeff Newbern 2003-2006 (c) Andriy Palamarchuk 2006
License | BSD-style (see the file LICENSE)
Maintainer | ross@soi.city.ac.uk
Stability | experimental
Portability | non-portable (type families)
Safe Haskell | None
Language | GHC2021

Control.Monad.Except.Class

Description

Computation type:
  Computations which may fail or throw exceptions.
Binding strategy:
  Failure records information about the cause/location of the failure. Failure values bypass the bound function, other values are used as inputs to the bound function.
Useful for:
  Building computations from sequences of functions that may fail or using exception handling to structure error handling.
Zero and plus:
  Zero is represented by an empty error and the plus operation executes its second argument if the first fails.
Example type:
  ``Either` `String` a`

The Error monad (also called the Exception monad).

Synopsis

- class Monad m => MonadError (m :: Type -> Type) where
  - type ErrorType (m :: Type -> Type)
  - throwError :: ErrorType m -> m a
  - catchError :: m a -> (ErrorType m -> m a) -> m a

# Documentation

class Monad m => MonadError (m :: Type -> Type) where Source #

The strategy of combining computations that can throw exceptions by bypassing bound functions from the point an exception is thrown to the point that it is handled.

Is parameterized over the type of error information and the monad type constructor. It is common to use ``Either` String` as the monad type constructor for an error monad in which error descriptions take the form of strings. In that case and many other common cases the resulting monad is already defined as an instance of the `MonadError` class. You can also define your own a monad type constructor other than ``Either` e`, in which case you will have to explicitly define an instance of the `MonadError` class.

Associated Types

type ErrorType (m :: Type -> Type) Source #

Methods

throwError :: ErrorType m -> m a Source #

Is used within a monadic computation to begin exception processing.

catchError :: m a -> (ErrorType m -> m a) -> m a Source #

A handler function to handle previous errors and return to normal execution. A common idiom is:

    do { action1; action2; action3 } `catchError` handler

where the `action` functions can call `throwError`. Note that `handler` and the do-block must have the same return type.

#### Instances

Instances details

MonadError IO Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType IO |
Instance details Defined in Control.Monad.Except.Class type ErrorType IO = IOError

Methods

throwError :: ErrorType IO -> IO a Source #

catchError :: IO a -> (ErrorType IO -> IO a) -> IO a Source #

MonadError (Either e) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (Either e) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (Either e) = e

Methods

throwError :: ErrorType (Either e) -> Either e a Source #

catchError :: Either e a -> (ErrorType (Either e) -> Either e a) -> Either e a Source #

MonadError m => MonadError (MaybeT m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (MaybeT m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (MaybeT m) = ErrorType m

Methods

throwError :: ErrorType (MaybeT m) -> MaybeT m a Source #

catchError :: MaybeT m a -> (ErrorType (MaybeT m) -> MaybeT m a) -> MaybeT m a Source #

Monad m => MonadError (ExceptT e m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (ExceptT e m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (ExceptT e m) = e

Methods

throwError :: ErrorType (ExceptT e m) -> ExceptT e m a Source #

catchError :: ExceptT e m a -> (ErrorType (ExceptT e m) -> ExceptT e m a) -> ExceptT e m a Source #

MonadError m => MonadError (IdentityT m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (IdentityT m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (IdentityT m) = ErrorType m

Methods

throwError :: ErrorType (IdentityT m) -> IdentityT m a Source #

catchError :: IdentityT m a -> (ErrorType (IdentityT m) -> IdentityT m a) -> IdentityT m a Source #

MonadError m => MonadError (ReaderT r m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (ReaderT r m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (ReaderT r m) = ErrorType m

Methods

throwError :: ErrorType (ReaderT r m) -> ReaderT r m a Source #

catchError :: ReaderT r m a -> (ErrorType (ReaderT r m) -> ReaderT r m a) -> ReaderT r m a Source #

MonadError m => MonadError (StateT s m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (StateT s m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (StateT s m) = ErrorType m

Methods

throwError :: ErrorType (StateT s m) -> StateT s m a Source #

catchError :: StateT s m a -> (ErrorType (StateT s m) -> StateT s m a) -> StateT s m a Source #

MonadError m => MonadError (StateT s m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (StateT s m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (StateT s m) = ErrorType m

Methods

throwError :: ErrorType (StateT s m) -> StateT s m a Source #

catchError :: StateT s m a -> (ErrorType (StateT s m) -> StateT s m a) -> StateT s m a Source #

(Monoid w, MonadError m) => MonadError (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (WriterT w m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (WriterT w m) = ErrorType m

Methods

throwError :: ErrorType (WriterT w m) -> WriterT w m a Source #

catchError :: WriterT w m a -> (ErrorType (WriterT w m) -> WriterT w m a) -> WriterT w m a Source #

(Monoid w, MonadError m) => MonadError (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (WriterT w m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (WriterT w m) = ErrorType m

Methods

throwError :: ErrorType (WriterT w m) -> WriterT w m a Source #

catchError :: WriterT w m a -> (ErrorType (WriterT w m) -> WriterT w m a) -> WriterT w m a Source #

(Monoid w, MonadError m) => MonadError (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (RWST r w s m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (RWST r w s m) = ErrorType m

Methods

throwError :: ErrorType (RWST r w s m) -> RWST r w s m a Source #

catchError :: RWST r w s m a -> (ErrorType (RWST r w s m) -> RWST r w s m a) -> RWST r w s m a Source #

(Monoid w, MonadError m) => MonadError (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (RWST r w s m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (RWST r w s m) = ErrorType m

Methods

throwError :: ErrorType (RWST r w s m) -> RWST r w s m a Source #

catchError :: RWST r w s m a -> (ErrorType (RWST r w s m) -> RWST r w s m a) -> RWST r w s m a Source #